local HL_OnLoad_EventFrame = CreateFrame("Frame")
HL_OnLoad_EventFrame:RegisterEvent("PLAYER_LOGIN")
HL_OnLoad_EventFrame:SetScript(
    "OnEvent",
    function(self, event)
        if event == "PLAYER_LOGIN" then
            DEFAULT_CHAT_FRAME:AddMessage(
                "|cFFFF0000Highlighter v1.4 |rby Kro has successfully loaded. Type /hl help..."
            )
        end
    end
)

local HL_Message_EventFrame = CreateFrame("Frame")

HL_Message_EventFrame:RegisterEvent("CHAT_MSG_CHANNEL")
HL_Message_EventFrame:SetScript(
    "OnEvent",
    function(self, event, ...)
        local arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9 = ...

        local msg = " "..string.lower(arg1)

        local author = string.lower(arg2:hsplit("-")[1])

        if Check_Match(msg) and Check_Ignore(author) then
            DEFAULT_CHAT_FRAME:AddMessage(
                "Found match from |cFFFF0000" .. author .. "|r from channel |cFFFF0000" .. arg9 .. "."
            )
            DEFAULT_CHAT_FRAME:AddMessage("|cFFFF0000Message: |r" .. arg1)
            PlaySound(12889, "master")
        end
    end
)

ignorelist = {}
phrases = {}

function Check_Ignore(author)
    for index, player in next, ignorelist do
        if string.match(author, player) then
            return false
        end
    end
    return true
end

function Check_Match(msg)
    if not next(phrases) == nil then
        return false
    end
    local foundmatch = false
    for index, words in next, phrases do
        for index, word in next, words do
            if word:find("!") == 1 then
                if string.match(msg, word:gsub("!", "")) ~= nil then
                    foundmatch = false
                    break
                end
            elseif string.match(msg, word) == nil or string.find(word, "^!") then
                foundmatch = false
                break
            else
                foundmatch = true
            end
        end
        if foundmatch == true then
            return true
        end
    end
    return false
end

local function Highlight_SlashCommandHandler(msg)
    local _, _, cmd, args = string.find(msg, "%s?(%w+)%s?(.*)")
    args = string.lower(args)
    --add entries

    if cmd == "add" then
        --clear all entries
        local words = {}
        local items = ""

        for ma in args:gmatch("|c.-item.-|r") do
            local id = ma:match("item:(%d+)")
            local itemname, itemlink = GetItemInfo(id)
            args:gsub(itemlink, "")
            items = items .. itemlink
            table.insert(words, string.lower(itemname))
        end

        args = args:gsub("|c.-item.-|r", "")

        for word in args:gmatch("%S+") do
            --REMINDER: %s fixes so that it only matches the start of a word since we added a space to the message during onevent
            table.insert(words, "%s"..word)
        end

        table.insert(phrases, words)
        DEFAULT_CHAT_FRAME:AddMessage('Added: "|cFFFF0000' .. args .. items .. '|r" to phrases.')
    elseif cmd == "clear" then
        --ls / list all entries
        phrases = {}
    elseif cmd == "list" or cmd == "ls" then
        --remove specific element in entries by index
        for index, words in next, phrases do
            local hlstring = index .. ". "
            for index, word in next, words do
                hlstring = hlstring .. word .. " "
            end
            DEFAULT_CHAT_FRAME:AddMessage(hlstring)
        end
    elseif cmd == "remove" or cmd == "rm" then
        --ignore messages containing phrases from players
        table.remove(phrases, tonumber(args))
    elseif cmd == "ignore" then
        --clear ignore list
        table.insert(ignorelist, args)
        DEFAULT_CHAT_FRAME:AddMessage('Added "|cFFFF0000' .. args .. '|r" to ignore list')
    elseif cmd == "clearignore" then
        ignorelist = {}
    elseif cmd == "ignorelist" then
        for index, player in next, ignorelist do
            DEFAULT_CHAT_FRAME:AddMessage(index .. ": " .. player)
        end
    elseif cmd == "help" then
        DEFAULT_CHAT_FRAME:AddMessage(
            "|cFFFF0000/hl add <Phrase> |r-- Phrase containing words to highlight. Use suffix ! to ignore a word"
        )
        DEFAULT_CHAT_FRAME:AddMessage("|cFFFF0000/hl list|r -- Lists all phrases and their indices")
        DEFAULT_CHAT_FRAME:AddMessage("|cFFFF0000/hl ls |r-- Same as /hl list")
        DEFAULT_CHAT_FRAME:AddMessage("|cFFFF0000/hl remove <Index> |r-- Removes phrase with <Index> from list")
        DEFAULT_CHAT_FRAME:AddMessage("|cFFFF0000/hl rm <Index> |r-- Same as /hl remove <Index>")
        DEFAULT_CHAT_FRAME:AddMessage("|cFFFF0000/hl ignore <Player> |r-- Ignores messages from specific player")
        DEFAULT_CHAT_FRAME:AddMessage("|cFFFF0000/hl ignorelist -- |rLists all ignored players")
        DEFAULT_CHAT_FRAME:AddMessage("|cFFFF0000/hl clear -- |rRemoves all entries in phrase list")
        DEFAULT_CHAT_FRAME:AddMessage("|cFFFF0000/hl clearignore -- |rRemoves all entries in ignore list")
        DEFAULT_CHAT_FRAME:AddMessage(
            'Example: "|cFFFF0000/hl add lf ony !lfg|r" will match "|cFFFF0000lf2m onyxia|r" but not "|cFFFF0000lfg onyxia|r"'
        )
    else
        DEFAULT_CHAT_FRAME:AddMessage("Unknown command try |cFFFF0000/hl help|r.")
    end
end
SlashCmdList["HIGHLIGHT"] = Highlight_SlashCommandHandler
SLASH_HIGHLIGHT1 = "/hl"

function string:hsplit(inSplitPattern, outResults)
    if not outResults then
        outResults = {}
    end
    local theStart = 1
    local theSplitStart, theSplitEnd = string.find(self, inSplitPattern, theStart)
    while theSplitStart do
        table.insert(outResults, string.sub(self, theStart, theSplitStart - 1))
        theStart = theSplitEnd + 1
        theSplitStart, theSplitEnd = string.find(self, inSplitPattern, theStart)
    end
    table.insert(outResults, string.sub(self, theStart))
    return outResults
end

function h_starts_with(str, start)
    return string.sub(String, 1, string.len(Start)) == Start
end

--TODO
--Add some sort of UI :'(

--TODO MAYBE:
--hdeactivate pause listening for phrase by index
--hactivate resume listening for phrase by index

--TODO MAYBE MAYBE:
--hpause/hstop pauses all activity
--hresume/hstart resumes all activity
